# stuff to be implemented externally:
Source10: kmodtool
%define   kmodtool bash %{SOURCE10}
# end stuff to be ...

# hardcode for now:
%{!?kversion: %define kversion 2.6.22.9-91.fc7}

%define kmod_name go7007
%define kverrel %(%{kmodtool} verrel %{?kversion} 2>/dev/null)

%define upvar ""
%ifarch i686
%define paevar PAE
%endif
%ifarch ppc
%define smpvar smp
%endif
%ifarch i686 x86_64
# xen uses a different version; ignore
#define xenvar xen
# don't build for debug kernels
#define debugvar debug PAE-debug
%endif
%{!?kvariants: %define kvariants %{?upvar} %{?smpvar} %{?paevar} %{?xenvar} %{?kdumpvar}}

Name:		%{kmod_name}-kmod
Version:	0.9.8
Release:	2.%(echo %{kverrel} | tr - _)
Summary:	Kernel module for wis-go7007 devices

Group:		System Environment/Kernel
License:	GPL
URL:		http://oss.wischip.com/
Source0:	http://oss.wischip.com/wis-go7007-linux-%{version}.tar.bz2
Patch0:		http://bart.ulyssis.org/go7007/wis-go7007_0.9.8_2.6.21.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
ExclusiveArch:	i586 i686 x86_64 ppc

BuildRequires:  ncurses-devel
BuildRequires:	fxload

%description
This package contains the wis-go7007 driver, a linux device driver for usb
video encoder and streammer


# magic hidden here:
%{expand:%(%{kmodtool} rpmtemplate %{kmod_name} %{kverrel} %{kvariants} 2>/dev/null)}


%prep
# to understand the magic better or to debug it, uncomment this:
#{kmodtool} rpmtemplate %{kmod_name} %{kverrel} %{kvariants} 2>/dev/null
#sleep 5
%setup -q -c -T -a 0 -n wis-go7007-linux-%{version}
%patch0 -p0
#grep -rlF '<linux/config.h>' wis-go7007-linux-%{version} \
#| xargs sed -i -e 's|<linux/config.h>|<linux/autoconf.h>|'

# make compile log more verbose
#sed -i.debug -e '/SILENT/s|^.*$|:|' 

for kvariant in %{kvariants} ; do
cp -a wis-go7007-linux-%{version} _kmod_build_$kvariant
done

%build
for kvariant in %{kvariants}
do
ksrc=%{_usrsrc}/kernels/%{kverrel}${kvariant:+-$kvariant}-%{_target_cpu}
cd _kmod_build_$kvariant
make KERNELSRC="${ksrc}" KERNELRELEASE=%{kverrel}${kvariant} \
  LINUXINCLUDE="-Iinclude -include include/linux/autoconf.h"
#-I%{_includedir}/v4l -I%{_includedir}/alsa-driver
cd ..
done


%install
rm -rf $RPM_BUILD_ROOT
for kvariant in %{kvariants}
do
ksrc=%{_usrsrc}/kernels/%{kverrel}${kvariant:+-$kvariant}-%{_target_cpu}
cd _kmod_build_$kvariant
mkdir -p $RPM_BUILD_ROOT/lib/modules/%{kverrel}${kvariant}/extra/%{kmod_name}
install -D -m 0644 kernel/*.ko $RPM_BUILD_ROOT/lib/modules/%{kverrel}${kvariant}/extra/%{kmod_name}
cd ..
done
chmod 0755 $RPM_BUILD_ROOT/lib/modules/*/extra/%{kmod_name}/*


%clean
rm -rf $RPM_BUILD_ROOT

%changelog
* Sat Jan 13 2007 kwizart < kwizart at gmail.com > - 0.9.8-2
- Updated patch with kernel 2.6.19

* Fri Dec 15 2006 kwizart < kwizart at gmail.com > - 0.9.8-1.kwizart.fc6
- Initial release.
